#!/bin/sh
# the next line restarts using tclsh \
exec tclsh8.0 "$0" "$@"

package require BioDesc
package require Extral

set i 0
while 1 {
	switch -- [lindex $argv $i] {
		-log {
			incr i
			set logfile [lindex $argv $i]
			incr i
			puts "logfile: $logfile"
			set log [open $logfile w]
		}
		-continue {
			incr i
			set logfile [lindex $argv $i]
			incr i
			set f [open $logfile]
			set line [gets $f]
			if ![string_equal [lindex $line 0] resultfile] {
				error "error in logfile"
			}
			set resultfile [lindex $line 1]
			if ![string length $resultfile] {
				unset resultfile
			}
			set files [lindex [gets $f] 1]
			set accns [lindex [gets $f] 1]
			if [llength $accns] {
				set done [read $f]
				set accns [list_lremove $accns $done]
			} else {
				unset accns
			}
			close $f
			set log [open $logfile a]
		}
		default {
			break
		}
	}
}
if ![info exists resultfile] {
	set resultfile [lindex $argv $i]
	incr i
	set files [lrange $argv $i end]
}

if ![string length $resultfile] {
	puts stderr "Format is \"[info script] ?-log logfile? ?-continue logfile? resultfile emblfile ?emblfile ...?\""
	exit 1
}

puts $log [list resultfile $resultfile]
puts $log [list files: $files]
flush $log

# get accn numbers
if ![info exists accns] { 
	puts "Searching accession numbers"
	set accns [eval bio_getaccns $files]
	puts $log [list toget $accns]
	flush $log
}

# Get EMBL file from net
set f [open $resultfile a]
foreach acc $accns {
	puts "Downloading $acc"
	if ![catch {embl_getentry $acc} data] {
		puts $f $data
		flush $f
		puts $log $acc
		flush $log
	} else {
		puts "Skipped $acc"
	}
}
close $f
close $log
