package require Class
Class subclass afilter

afilter method set {key proc {data {}}} {
	private $object filter filterdata
	set filter($key) $proc
	set filterdata($key) $data
}

afilter method unset {key} {
	private $object filter filterdata
	unset filter($key)
	unset filterdata($key)
}

afilter method list {} {
	private $object filter
	array get filter
}

afilter method listfull {{pattern *}} {
	private $object filter filterdata
	set result {}
	foreach field [array names filter] {
		if {[string match $pattern $field]} {
			lappend result $field $filter($field) $filterdata($field)
		}
	}
	return $result
}

afilter method filter {alistVar {keys {}}} {
	upvar $alistVar alist
	private $object filter filterdata
	set result {}
	if {![llength $keys]} {
		set pos 1
		foreach {key value} $alist {
			if {[info exists filter($key)]} {
				lset alist $pos [$filter($key) $value $filterdata($key)]
			}
			incr pos 2
		}
	} else {
		set pos 0
		foreach key $keys {
			if {[info exists filter($key)]} {
				lset alist $pos [$filter($key) [lindex $alist $pos] $filterdata($key)]
			}
			incr pos 1
		}
	}
}

afilter method prefixfilter {prefix alistVar {keys {}}} {
	upvar $alistVar alist
	private $object filter filterdata
	set result {}
	if {![llength $keys]} {
		set pos 1
		foreach {key value} $alist {
			if {[info exists filter($prefix$key)]} {
				lset alist $pos [$filter($prefix$key) $value $filterdata($key)]
			}
			incr pos 2
		}
	} else {
		set pos 0
		foreach key $keys {
			if {[info exists filter($prefix$key)]} {
				lset alist $pos [$filter($prefix$key) [lindex $alist $pos] $filterdata($key)]
			}
			incr pos 1
		}
	}
}
