package require Extral
package require dbi
package require dbi_postgresql
dbi_postgresql db
db open commonality

db exec {
	create table "oligo" (
	"oligo" char(16),
	"seq" integer,
	"pos" integer)
}
pg exec {
	create table "num" (
	"oligo" char(16),
	"num" integer)
}
db exec {create index "oligo_oligo" on "oligo"("oligo")}

	set seq [string toupper [file_read /data/genomes/biodb/dbdata/seq/1]]

proc commonality_prepare {db seqid} {
	set seqid 1
	set size 10
	set seq [string toupper [file_read /home/peter/dev/BioTcl/tests/biodb/seq/1]]
	set len [string length $seq]
	set endpos [expr {$len - $size}]
	set c 0
	set f [open /tmp/pgtemp.txt w]
	for {set pos 0} {$pos < $endpos} {incr pos 1} {
		if {$c == 1000} {
			set c 0
			puts $pos
		}
		incr c
		set fragment [string range $seq $pos [expr {$pos+15}]]
		puts $f $fragment\t$seqid\t$pos
	}
	close $f
	$db exec {copy "oligo" from '/tmp/pgtemp.txt'}
}

proc commonality_prepare {biodb seqid} {
	set seqid 1
	set size 10
	set db [$biodb db]
	set seq [string toupper [$biodb sequence get seq $seqid]]
	set len [string length $seq]
	set endpos [expr {$len - $size}]
	set f [open /tmp/temp.txt w]
	for {set pos 0} {$pos < $endpos} {incr pos 1} {
		if {[expr {$pos%1000}] == 0} {puts $pos}
		set fragment [string range $seq $pos [expr {$pos+15}]]
		puts $f [format %s%5d%15d $fragment $seqid $pos]
	}
	close $f
	puts "create exttable"
	catch {$db exec {drop table ext_tbl}}
	$db exec {
		create table ext_tbl external file '/tmp/temp.txt' (
			oligo char(16),
			seq char(5),
			pos char(15),
			newline char(1)
		)
	}
	puts "copy exttable"
	$db exec {
		insert into "oligo" select oligo,cast(seq as integer),cast(pos as integer) from ext_tbl
	}
}
$db exec {delete from "oligo"}
time {commonality_prepare db 1}

$db exec {create view "nums"("oligo","num") as select "oligo",count(*) from "oligo" group by "oligo"}
set h [$db exec {select * from "nums" where "num" >= 5}]

# dbm ???
catch {set seq [string toupper [db get source:10 dnaseq]]}
catch {file delete temp.bsd}
package require Extral
package require dbm
dbm create bsddb temp.bsd
dbm open bsddb mdb temp.bsd
set seq [string toupper [file_read /home/peter/dev/BioTcl/tests/biodb/seq/1]]
set seq [string toupper [db sequence get seq 1]]
proc do {seq} {
	set size 4
	set len [string length $seq]
	set endpos [expr {$len - $size}]
	set c 0
	for {set pos 0} {$pos < $endpos} {incr pos 1} {
		if {$c == 1000} {
			set c 0
			puts $pos
		}
		incr c
		set fragment [string range $seq $pos [expr {$pos+$size-1}]]
		set num [mdb get $fragment 0]
		incr num
		mdb set $fragment $num
	}
}
time {do $seq}
