if 0 {
proc _conv_biodb_embl_multi_out {key value {size 72} {separator { }} {pre {}}} {
	if {[string_equal $pre {}]} {set pre $key}
	_conv_out $pre
	set len [string length $value]
	while {1} {
		if {$len < $size} {
			_conv_out "$value\n"
			break
		}
		set pos [string last $separator $value $size]
		if {$pos == -1} {set pos $size}
		_conv_out "[string range $value 0 $pos]\n"
		incr pos
		set value [string range $value $pos end]
		incr len -$pos
		if {$len == 0} break
		_conv_out "$key"
	}
}

proc _conv_biodb_embl_multi_out_list {key value {seperator "; "} {end .} {intro {}}} {
	_conv_out $key$intro
	set pos 0
	set sep 0
	foreach keyw $value {
		if {$sep} {
			_conv_out $seperator
		} else {
			set sep 1
		}
		set len [string length $keyw]
		incr pos $len
		if {$pos > 69} {
			_conv_out "\n$key"
			set pos $len
		}
		_conv_out $keyw
	}
	_conv_out "$end\n"
}

array set _conv_biodb_embl_qualifiers [file_read [file join $::bio::dir conf embl_qualifiers.txt]]
array set _conv_biodb_embl_qualifiers {proteinseq p}

proc _conv_biodb_embl_ftqualifiers {biodb ft exclude ftsnotlist} {
#putsvars db ft exclude
	set fields [$biodb fields $ft]
	set fields [list_lremove $fields $exclude]
	foreach field $fields {
		set values [$biodb get $ft $field]
		if {$ftsnotlist} {
			set values [list $values]
		}
		foreach value $values {
			switch [get ::_conv_biodb_embl_qualifiers($field) ""] {
				n {
					set value "/$field"
				}
				s {
					if {[string first " " $value] == -1} {
						set value "/$field=$value"
					} else {
						set value "/$field=\"$value\""
					}
				}
				t {
					set value "/$field=\"$value\""
				}
				p {
					set value "/translation=\"$value\""
				}
				default {
					set value "/$field=\"$value\""
				}
			}
			_conv_biodb_embl_multi_out "FT                   " $value 58
		}
	}
}

proc _conv_biodb_embl_ftloc {biodb ft} {
	if {[catch {$biodb get $ft _parts} parts]} {
		set start [$biodb get $ft start 0]
		set length [$biodb get $ft length 0]
		if {$length == 0} {
			if {![catch {$biodb get $ft start_span} result]} {
				return "$start^[expr {$start+$result}]"
			} else {
				return "$start^[expr {$start+1}]"
			}
		}
		incr start
		set partial [$biodb get $ft partial n]
		if {[inlist {s b} $partial]} {set pstart <} else {set pstart ""}
		if {[inlist {e b} $partial]} {set pend >} else {set pend ""}
		if {![catch {$biodb get $ft start_span} result]} {
			set fstart "($pstart$start.[expr {$start+$result-1}])"
		} else {
			set fstart "$pstart$start"
		}
		if {$length == 1} {return $fstart}
		set end [expr {$start+$length-1}]
		if {![catch {$biodb get $ft end_span} result]} {
			set end "($pend$end.[expr {$end+$result-1}])"
		} else {
			set end "$pend$end"
		}
		set complement [$biodb get $ft complement 0]
		if {$complement} {
			return "complement($fstart..$end)"
		} else {
			return "$fstart..$end"
		}
	} else {
		set acc [$biodb get [$biodb get $ft _sequence] acc]
		set result join(
		set sep 0
		foreach part $parts {
			if {$sep} {append result ","} else {set sep 1}
			set loc [_conv_biodb_embl_ftloc $biodb $part]
			set pacc [$biodb get [$biodb get $part _sequence] acc]
			if {[string_equal $pacc $acc]} {
				append result $loc
			} else {
				append result $pacc:$loc
			}
		}
		append result )
		return $result
	}
}

proc conv_biodb_embl {args} {
putsvars args
	set opt(-features) all
	cmd_args conv_biodb_embl {
		-sequences {query "query to select sequences to go in the output"}
		-features {query "query to select features to go in the output, if -sequences is specified, only matching features of the given sequences will be processed"}
		-channel {channel "channel for results; if this option is not given, result will be returned"}
		-noseq {switch "don't output actual sequences"}
		-ftsnotlist {switch "do not see ft qualifiers as a list"}
	} {biodb} $args
	set dbseq [[$biodb db] clone]
	set dbft [[$biodb db] clone]
	if [info exists opt(-sequences)] {
		if {![isint [lindex $opt(-sequences) 0]]} {
			$dbseq exec -usefetch [subst {select * from "seq" where $opt(-sequences)}]
		} else {
			$dbseq exec -usefetch [subst {
				select * from "seq"
				where "id" in ([join $opt(-sequences) ,])
			}]
		}
	} elseif [string_equal $opt(-features) all] {
		$dbseq exec -usefetch {select * from "seq" where $opt(-sequences)}
	} else  {
		$dbseq exec -usefetch [subst {
			select * from "seq"
			where "id" in ([join [[$biodb db] exec -flat [subst {select distinct "seq" from "ft" where $opt(-features) order by "seq"}] ,])
		}]
		set sequences [[$biodb db] exec -flat [subst {select distinct "seq" from "ft" where $opt(-features) order by "seq"}]]
	}
	set ::bio::_ ""
	if {[info exists opt(-channel)]} {
		proc _conv_out {value} "puts -nonewline $opt(-channel) \$value"
	} else {
		proc _conv_out {value} {append ::bio::_ $value}
	}
	foreach sequence $sequences {
	set seqfields [$dbseq fetch fields]
	while 1 {
		if {[catch {$dbseq fetch} seqline]} break
		foreach $seqfields $seqline break
		if {[catch {$biodb sequence get $sequence} seq]} {
			puts stdout "skipped $sequence: does not contain a sequence"
			continue
		}
		_conv_out "ID   [get locus $acc]  [get dataclass unkown]; [get type DNA]; [get division ?]; $length BP.\n"
		_conv_out "XX\n"
		_conv_out "AC   $acc;"
		if {[llength $oldacc]} {
			_conv_out "[join $result "; "];"
		}
		_conv_out "\nXX\n"
		_conv_out "SV   [get version $acc.1]\nXX\n"
		if {[string length $nid]} {
			_conv_out "NI   $nid\nXX\n"
		}
		set date [get date ""]
		if [catch {time_scan $date} result] {
			foreach line [split $date \n] {
				_conv_out "DT   $line\n"
			}
		} else {
			set date [string toupper [time_format $result "%d-%b-%Y"]]
			set rel [get release ?]
			_conv_out "DT   $date (Rel. $rel, Created)\n"
			set update [get update ""]
			if [catch {time_scan $update} result] {
				set update $date
			} else {
				set update [string toupper [time_format $result "%d-%b-%Y"]]
			}
			set rel [get update_release ?]
			set version [get update_version ?]
			_conv_out "DT   $update (Rel. $rel, Last updated, Version $version)\n"
		}
		_conv_out "XX\n"
		if {![string length $def]} {
			set result "[get organism ""] [get molecule ""]"
		}
		_conv_biodb_embl_multi_out "DE   " $result
		_conv_out "XX\n"
		set keywords [get keywords ""]
		if {[string equal $keywords ""]} {
			_conv_out "KW   .\n"
		} else {
			_conv_biodb_embl_multi_out_list "KW   " $keywords
		}
		_conv_out "XX\n"
		if {[string equal $organism ""]} {
			_conv_out "OS   unidentified"
		} else {
			_conv_out "OS   $organism"
		}
		if {![string equal $common_name ""]} {
			_conv_out " ($common_name)"
		}
		_conv_out "\n"
		if {[string equal $taxonomy ""]} {
			_conv_out "OC   .\n"
		} else {
			_conv_biodb_embl_multi_out_list "OC   " $taxonomy
		}
		if {![string equal $organel ""]} {
			_conv_out "OG   $organel\n"
		}
		catch {unset cref}
		set rn 1
		if {[catch {$biodb values $fts _ref} refs]} {
			set refs [$biodb get $sequence _ref ""]
		} elseif {![catch {$biodb values $sequence _ref} result]} {
			eval lappend refs $result
		} else {
			set refs ""
		}
		$dbft exec -usefetch {select * from "ref" where "seq" = ?} $sequence
		set reffields [$dbft fetch fields]
		while 1 {
			set refline [$dbft fetch]
			foreach $reffields $refline break
!
############# working on this #######################
		foreach [$dbft fetch field] [$biodb get $sequence _ref ""] \
		refpos [$biodb get $sequence refpos ""] \
		refnum [$biodb get $sequence refnum ""] {
			if {[string_equal $refnum ""]} {
				set refnum $rn
				incr rn
			}
			_conv_out "XX\nRN   \[$refnum\]\n"
			set cref($ref) $refnum
			if {![catch {$biodb get $ref comment} result]} {
				_conv_biodb_embl_multi_out "RC   " $result
			}
			if {![string_equal $refpos ""]} {
				set result ""
				set sep 0
				foreach {start end} $refpos {
					if {$sep} {append result ", "} else {set sep 1}
					append result "$start-$end"
				}
				_conv_biodb_embl_multi_out "RP   " $result
			}
			set rxfields [$biodb fields $ref]
			foreach rxfield [list_select -glob $rxfields rx_*] {
				_conv_out "RX   [string range $rxfield 3 end]; [$biodb get $ref $rxfield].\n"
			}
			if {![catch {$biodb get $ref authors} result]} {
				_conv_biodb_embl_multi_out_list "RA   " $result ", " \;
			}
			if {![catch {$biodb get $ref title} result]} {
				_conv_biodb_embl_multi_out "RT   " "\"$result.\"\;"
			} else {
				_conv_out "RT   ;\n"
			}
			if {![catch {$biodb get $ref journal} result]} {
				if {[string_equal $result Unpublished]} {
					_conv_out "RL   Unpublished.\n"
				} else {
					_conv_out "RL   $result [$biodb get $ref volume ?]:[$biodb get $ref pages 0-0]([$biodb get $ref year ?]).\n"
				}
			} elseif {![catch {$biodb get $ref submission} result]} {
				_conv_out "RL   Submitted ([$biodb get $ref date]) to the EMBL/GenBank/DDBJ databases.\n"
				_conv_biodb_embl_multi_out "RL   " [$biodb get $ref place]
			} elseif {![catch {$biodb get $ref book} result]} {
				_conv_biodb_embl_multi_out_list {RL   } [$biodb get $ref editors ""] ", " " (Eds.);" "(in) "
				_conv_out "RL   $result:[$biodb get $ref pages "0-0"];\n"
				_conv_out "RL   [$biodb get $ref place ?] ([$biodb get $ref year ?]).\n"
			} elseif {![catch {$biodb get $ref thesis} result]} {
				set result "Thesis ([$biodb get $ref year ?]), [$biodb get $ref place ?]"
				_conv_biodb_embl_multi_out "RL   " $result
			} elseif {![catch {$biodb get $ref patent} result]} {
				if [catch {$biodb get $ref date} date] {
					set date ?
				} else {
					set date [string toupper [time_format [time_scan $date] "%d-%b-%Y"]]
				}
				_conv_out "RL   Patent number $result-[$biodb get $ref type ?]/[$biodb get $ref serial ?], $date.\n"
				_conv_biodb_embl_multi_out_list "RL   " [$biodb get $ref applicants ""]
			}
		}
		_conv_out "XX\n"
		set xx 0
		foreach dr [$biodb get $sequence dbref ""] {
			set xx 1
			_conv_out "DR   [join $dr "; "].\n"
		}
		if {$xx} {_conv_out "XX\n"}
		if {![catch {$biodb get $sequence comment} result]} {
			_conv_biodb_embl_multi_out "CC   " $result
			_conv_out "XX\n"
		}
		if [string_equal $opt(-features) all] {
			$dbft exec -usefetch  {select * from "ft"}
		} else {
			$dbft exec -usefetch [subst {
				select * from "ft"
				where "seq" = $sequence and ($opt(-features))
			}]
		}
		_conv_out "XX\nFH   Key             Location/Qualifiers\nFH\n"
		_conv_out "FT   sequence          1..$length\n"
		_conv_biodb_embl_ftqualifiers $biodb $sequence {
			acc oldacc id dataclass molecule division
			date release update update_release update_version
			updated def keywords taxonomy dnaseq start length _ref refpos refnum
			nid date organel comment dbref version organism
		} $opt(-ftsnotlist)
		if {![catch {$biodb get $sequence organel} result]} {
			_conv_biodb_embl_multi_out "FT                   " "/[string tolower $result]"
		}
		if {![catch {$biodb get $sequence organism} result]} {
			_conv_biodb_embl_multi_out "FT                   " "/organism=\"$result\""
		}
		set starts {}
		foreach ft $fts {
			if {![catch {$biodb get $ft start} start]} {
				lappend starts $start
			} else {
				set parts [$biodb get $ft _parts]
				lappend starts [$biodb get [lindex $parts 0] start]
			}
		}
		set fts [ssort -reflist $starts -integer $fts]
		foreach ft $fts {
			set ftkey [$biodb get $ft ftkey]
			if {[string_equal $ftkey sequence]} continue
			_conv_biodb_embl_multi_out "FT                   " \
				"[_conv_biodb_embl_ftloc $biodb $ft]" \
				58 , "FT   [format "%-15.15s " $ftkey]"
			if {![catch {$biodb get $ft _ref} result]} {
				foreach ref $result {
					_conv_out "FT                   /citation=\[$cref($ref)\]\n"
				}
			}
			_conv_biodb_embl_ftqualifiers $biodb $ft {
				ftkey _sequence acc updated _parts
				start length partial complement start_span end_span location _ref
			} $opt(-ftsnotlist)
		}
		set fr [seq_histo -windowsize 1 -sets {A C G T} [string toupper $seq]]
		_conv_out "XX\nSQ  Sequence $length BP"
		foreach base {A C G T} {
			if {[catch {map_get $fr $base} num]} {set num 0}
			_conv_out "; $num $base"
		}
		if {[catch {map_get $fr *} num]} {set num 0}
		_conv_out "; $num other;"
		if {![info exists opt(-noseq)]} {
			regsub -all {(..........)} $seq {\1 } seq
			regsub -all {(.......... .......... .......... .......... .......... ..........) } $seq "\\1\n    " seq
			_conv_out "\n    [string trimright $seq " \n"]\n"
		} else {
		_conv_out "\n"
		}
		_conv_out "//\n"
	}
	return $::bio::_
}
}}}