#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

package require BioTcl
package require Extral
package require Tk

#if {![llength $argv]} {
#	set file [tk_getOpenFile]
#} else {
#	set file [lindex $argv 0]
#}

set project chrYvsX
set file /data/peter/cblast/chrY.fa
set project mb_vs_mt_x
set project mb_vs_mt
set file /data/peter/cblast/mb_BX248333.fna
set project mp_vs_mt
set project mp_vs_mt_x
set file /data/peter/cblast/mt_AE000516.fna
set project cc_vs_ml
set project cc_vs_ml_x
set file /data/peter/cblast/cc_NC_002696.fna
set project chrYvsX_x
set file /data/peter/cblast/chrY.fa
set project hs22_mm5
set file /data/peter/cblast/hs_chr22.fa

set repeatfile /data/peter/cblast/chrY.fas.out
set blastfile /data/peter/cblast/$project.xml

catch {db close}
catch {db destroy}
set database /data/peter/cblast/$project.biodb
Biodb new db

if 0 {
	catch {file delete -force $database}
	db create $database
	db open $database
	puts "loading $file"
	conv_fasta_biodb -log stdout -name [file tail [file root $file]] db $file
	
	# biodb_import_repeatmasker db $repeatfile
	biodb_import_blast -transmax 500 db $blastfile
} else {
	db open $database
}

canvas .c
.c configure -xscrollcommand {.h set} -yscrollcommand {.v set}
scrollbar .v -command {.c yview}
scrollbar .h -orient horizontal -command {.c xview}
grid .c .v -sticky nwse
grid .h -sticky nwse
grid columnconfigure . 0 -weight 1
grid rowconfigure . 0 -weight 1

set rlen [db get {seq 1} length]
set dlen [db get {blast 1} hit_full_length]
set w [winfo width .c]
set h [winfo height .c]
set hscale [expr {$rlen/$h}]
set vscale [expr {$dlen/$w}]
set scale [lmath_max [list $vscale $hscale]]
set scale 10000

set num 0
unset -nocomplain forw
unset -nocomplain rev
unset -nocomplain lforw
unset -nocomplain lrev
foreach {id start end complement expect hit_size hit_start hit_end hit_complement} [[db db] exec -flat {
	select id,start,end,complement,expect,hit_size,hit_start,hit_end,hit_complement from blast
	where hit_size > 50
}] {
	set start [expr {$start/$scale}]
	set hit_start [expr {$hit_start/$scale}]
	if {![info exists forw($start,$hit_start)]} {
		set forw($start,$hit_start) 0
		set rev($start,$hit_start) 0
		set lforw($start,$hit_start) {}
		set lrev($start,$hit_start) {}
	}
	if {(!$complement && !$hit_complement) || ($complement && $hit_complement)} {
		incr forw($start,$hit_start) $hit_size
		lappend lforw($start,$hit_start) $hit_size
	} else {
		incr rev($start,$hit_start) $hit_size
		lappend lrev($start,$hit_start) $hit_size
	}
}

set min 0
set ymax [expr {$rlen/$scale}]
.c configure -bg white
.c delete all
foreach name [array names forw] {
	set color white
	if {($forw($name) < $min) && ($rev($name) < $min)} continue
	foreach {y x} [split $name ,] break
	# set y [expr {$ymax-$y}]
	if {$rev($name) > 0} {
		set rp [expr {$rev($name)*100/$scale}]
		foreach {pct color} {1 #ffe7e7 100 blue} {
			if {$rp < $pct} break
		}
		# set color [lindex {#ffe7e7 #ffd7d3 #ffbbbb #ffa7a4 #ff8480 #ff6164 #ff3135 #db0003} $fp]
	} else {
		set rp 0
	}
	if {$forw($name) > 0} {
		set fp [expr {$forw($name)*100/$scale}]
		foreach {pct color} {1 #ffe7e7 100 black} {
			if {$fp < $pct} break
		}
		# set color [lindex {grey90 grey80 grey70 grey60 grey50 grey40 grey30 black} $fp]
	} else {
		set fp 0
	}
	# take 1 (hum)
	if {$fp > 40} {
		set color black
	} elseif {$rp > 40} {
		set color darkgreen
	} elseif {$fp > 0} {
		if {$rp > 0} {
			set color red
		} else {
			set color grey70
		}
	} else {
		set color green
	}
	# take 2 (bact)
	if {($fp > 0) && ($rp == 0)} {
		set color black
	} elseif {($rp > 0) && ($fp == 0)} {
		set color darkgreen
	} elseif {$fp > 0} {
		if {$rp > 0} {
			set color red
		} else {
			set color grey70
		}
	} else {
		set color green
	}
	# Take 3
	set strip {1 white 10 grey90 20 grey80 40 grey70 60 grey60 70 grey50 80 grey40 90 grey30 100 black}
	set strip {1 white 5 grey90 10 grey80 20 grey70 30 grey60 40 grey50 50 grey40 60 grey30 100 black}
	foreach {pct color} $strip {
		if {$fp < $pct} break
	}

	.c create rectangle $x $y [expr {$x+1.01}] [expr {$y+1.01}] -fill $color -outline {}
}
.c configure -scrollregion [.c bbox all]

set zoom 2
.c scale all 0 0 $zoom $zoom
.c configure -scrollregion [.c bbox all]
