proc bio_filetype {file} {
	set f [open $file]
	set data [read $f 1000]
	close $f
	switch -regexp -- $data {
		{^[^\n]+\n\^\^\n} {
			return seqman
		}
		{^ID   } {
			return embl
		}
		{^LOCUS       } {
			return gbk
		}
		{^# RnaViz structure} {
			return rnaviz1
		}
		{header Classy::Canvas} {
			return rnaviz2
		}
		{^#reference file DCSE} {
			return dcseref
		}
		"^\[ \t\]+\[0-9\]+\[ \t\]+ENERGY =" {
			return ct
		}
		{^>} {
			return fasta
		}
		{^(#[^\n]*\n)*[^[:space:]]+[[:space:]]+[^[:space:]]+[[:space:]]+[^[:space:]]+[[:space:]]+[0-9]+[[:space:]]+[0-9]+} {
			return gff
		}
	}	
	set line [lindex [split $data \n] 0]
	switch -regexp -- $line {
		"^P|D|R*\[ \t\]+\[0-9\]+\[ \t\]+\[0-9\]+\[ \t\]*$" {
			return dcseali
		}
		default {
			error "Format of file \"$file\"not recognised"
		}
	}
}
