proc sputnik_run {source dest} {
	set sputnik $::bio::external(sputnik)
	set f [open $dest.runinfo w]
	puts $f [list source $source]
	puts $f [list time [clock format [clock seconds] -format "%Y-%m-%d %H:%M:%S"]]
	close $f
	exec $sputnik $source > $dest 2>/tmp/log
}

proc bio_sputnik {db source} {
	# $db class add sputnik
	set sputnik $::bio::external(sputnik)
	set tempsrc [tempfile]
	set tempdst [tempfile]
	set f [open $tempsrc w]
	puts $f ">work;"
	puts $f [$db get $source dnaseq]
	close $f
	exec $sputnik $tempsrc > $tempdst
	set eventid [biodb_import_sputnik $db $tempdst]
	$db set $eventid type run
	file delete $tempsrc
	file delete $tempdst
	return $eventid
}

proc biodb_import_sputnik {biodb source} {
	if {[file exists $source.runinfo]} {
		set c [file_read $source.runinfo]
	} else {
		set c {}
	}
	$biodb begin
	if [catch {
		set eventid [$biodb event type import sourcetype sputnik source $source options $c]
		set f [open $source]
		set line [gets $f]
		while {![eof $f]} {
			set line [gets $f]
			if {[string equal [string index $line 0] >]} {
				if [catch {$biodb scanid [string range $line 1 end] acc} seqid] {
					set seqid [$biodb scanid $source acc]
				}
			} else {
				foreach {rpt_unit unit_size unit_number start end length sputnik_score} $line break
				set ft [$biodb new sputnik]
				incr start -1
				incr end -1
				$biodb set $ft event [lindex $eventid 1] run [lindex $run 1] \
					seq [lindex $seqid 1] ftkey repeat_region start $start end $end complement 0 \
					rpt_unit $rpt_unit unit_size $unit_size unit_number $unit_number \
					sputnik_score $sputnik_score
				log "$ft $seqid $unit_size*$unit_number"
			}
		}
	} result] {
		$biodb rollback
		return -code error -errorinfo $::errorInfo $result
	} else {
		$biodb commit
	}
	return $eventid
}

