package require ClassyTk
Classy::Frame subclass bio::MapWidget

bio::MapWidget method init {args} {
	set w [super init]
	canvas $object.c -scrollregion {0 0 297m 210m} -width 10c -height 10c \
		-yscrollcommand [list $object.vbar set] \
		-xscrollcommand [list $object.hbar set]
	scrollbar $object.vbar -orient vertical \
		-command [list $object.c yview] \
		-highlightthickness 0
	scrollbar $object.hbar -orient horizontal \
		-command [list $object.c xview] \
		-highlightthickness 0
	frame $object.frame
	grid $object.c $object.vbar -sticky nwse
	grid $object.hbar -sticky nwse
	grid columnconfigure $object 0 -weight 1
	grid rowconfigure $object 0 -weight 1
	set object map
	set title "Visual representation of sequence annotation"
	private $object titleid maps
	set titleid [.c create text 8m 10m]
	$object.c itemconfigure $titleid -anchor w -font {arial 14 bold} -text $title
	bio::Map new $object.map1 -canvas $object.c -tag page1 -start 0 -end 50000 -area {25m 20m 277m 200m} -yspacing 25 -baselinewidth 0.4
	set maps $object.map1
	return $object
}

#doc {Map command destroy} cmd {
#pathname destroy 
#} descr {
#}
bio::MapWidget method destroy {} {
	private $object options maps
	::Classy::busy
	foreach map $maps {
		$map destroy
	}
	catch {$options(-canvas) delete $options(-tag)}
	update idletasks
	::Classy::busy remove
}

